; XIVO Dialplan
; Copyright (C) 2008-2014  Avencall
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License along
; with this program; if not, write to the Free Software Foundation, Inc.,
; 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

[xivo-initconfig]
exten = _XXXXXX,1,NoOp(Initialisation of provisioning)
same  =         n,Set(XIVO_PROVCODE=${EXTEN})
same  =         n,Goto(xivo-provisioning,s,1)

exten = autoprov,1,NoOp(Reinitialisation of provisioning)
same  =          n,Set(XIVO_PROVCODE=autoprov)
same  =          n,Authenticate(9486)
same  =          n,Goto(xivo-provisioning,s,1)

exten = sccp,1,NoOp(SCCP provisioning)
same  =      n,Read(XIVO_PROVCODE,,6)
same  =      n,GotoIf($["x${XIVO_PROVCODE}" = "x"]?fail)
same  =      n,Goto(xivo-provisioning,s,1)
same  =      n(fail),Playback(auth-incorrect)
same  =      n,Hangup()

[xivo-provisioning]
exten = s,1,Answer()
same  =   n,Gosub(ip-${CHANNEL(channeltype)},1)    
same  =   n,AGI(agi://${XIVO_AGID_IP}/provision,${XIVO_PROVCODE},${XIVO_DEV_IP})
same  =   n,GotoIf(${XIVO_PROV_OK}?ok:fail)
same  =   n(ok),Playback(auth-thankyou)
same  =   n,Hangup()
same  =   n(fail),Playback(prov-error)
same  =   n,Hangup()

exten = ip-SIP,1,Set(XIVO_DEV_IP=${CHANNEL(peerip)})
same  =        n,Return()

exten = ip-SCCP,1,Set(XIVO_DEV_IP=${SCCP_DEVICE_IP})
same  =         n,Return()

exten = ip-PJSIP,1,Set(RADDR=${CHANNEL(pjsip,remote_addr)})
same  = 	 n,Set(XIVO_DEV_IP=${CUT(RADDR,:,1)})
same  =          n,Return()
